//////////////////////////////////////////////////////////
//Bildverschlüsselung durch XOR als Beispiel 
//für das Laden, Bearbeiten und Speichern großer Bilder.
///////////////////////////////////////////////////////

PImage bild, bildSchluessel, bildVerschluesselt;
int n=0;
int dimX=0; //Bildbreite
int dimY=0; //Bildhöhe
int anzahlPixel;
boolean fertig = false;
PFont font;
///////////////////////////////////////////////////
void setup() {
 File fBild = new File(dataPath("bild.png"));
 File fChaos = new File(dataPath("bildSchluessel.png"));
 File fVerschl = new File(dataPath("bildVerschluesselt.png"));
 if (fBild.exists())
 {
  bild = loadImage("bild.png");
  dimX = bild.width; 
  dimY = bild.height;
 }
 if ( fChaos.exists())
 {
  bildSchluessel = loadImage("bildSchluessel.png");
  dimX = bildSchluessel.width; 
  dimY = bildSchluessel.height;
 }
 if ( fVerschl.exists())
 {
  bildVerschluesselt = loadImage("bildVerschluesselt.png");
  dimX = bildVerschluesselt.width; 
  dimY = bildVerschluesselt.height;
 }
 
 anzahlPixel = dimX*dimY;
 n = 4*anzahlPixel;// Kleinere n zeigen noch rudimentäre Bildinformationen
 surface.setSize(dimX,dimY);  
 font = loadFont("ArialMT-18.vlw");
 background(255); 
 fill(0);noStroke();
 textFont(font);
 
}
/////////////////////////////////////////////////////////

void draw(){
 if(!fertig){
     text("Ver- und entschlüsseln von Bildern mit XOR",50 ,30);
     text("Zunächst mit Taste 'c'einen Schlüssel erstellen. Danach Sketch neu starten.",50,100);
     text("Das Schlüsselbild wird automatisch im data-Ordner abgespeichert.",50,130);
     text("Verschlüsseln mit 'v'-Taste.  -  Entschlüsseln mit 'e'-Taste.",50,160);   
     text("Das verschlüsselte Bild wird automatisch im data-Ordner abgespeichert.",50,190);
     text("Das entschlüsselte Bild wird automatisch im Programmordner abgespeichert.",50,220);
 } 
 if(fertig){
   image(bild,0,0);
 }
}


//Verschlüsseln
void verschluesseln(){ 
  bildVerschluesselt = createImage(dimX,dimY,RGB);
  for(int k = 0; k<dimX*dimY;k++){
    bildVerschluesselt.pixels[k]=  bild.pixels[k] ^ bildSchluessel.pixels[k];
  }
  fertig = true;
  bild = bildVerschluesselt; 
  bild.save("data/bildVerschluesselt.png");
}
//Entschlüsseln
void entschluesseln(){
  bild= createImage(dimX,dimY,RGB);
  for(int k = 0; k<dimX*dimY;k++){
    bild.pixels[k]=  bildVerschluesselt.pixels[k] ^ bildSchluessel.pixels[k];
  }
  fertig = true;
  //bild = bildVerschluesselt; 
  bild.save("bild.png");
}
/////////////////////////////////////////////////////////////
//Chaosbild für Schlüssel erzeugen
////////////////////////////////////////////////////////////
void chaosBildErzeugen(){
  
  bildSchluessel = createImage(dimX,dimY,RGB);
  
  for (int i = 0; i < anzahlPixel; i++) {    
      bildSchluessel.pixels[i]= color(random(255),random(255),random(255));
  }
  
  color tauschA = color(0,0,0);
  color tauschB = color(0,0,0); 
  int s,t;
  for(int i = 0; i<n; i++){
     s = (int)random(anzahlPixel);
     t = (int)random(anzahlPixel);
     tauschA = bildSchluessel.pixels[s];
     tauschB = bildSchluessel.pixels[t];
     bildSchluessel.pixels[t] = tauschA;
     bildSchluessel.pixels[s] = tauschB;
  }
  fertig = true;
  bild = bildSchluessel; 
  bild.save("data/bildSchluessel.png");
  
}
/////////////////////////////////////////////////////
//Verschlüsseln oder entschlüsseln?
/////////////////////////////////////////////////////
void keyPressed() { 
  if (key == 'c' ) {
    chaosBildErzeugen();
  }  
  if (key == 'v' ) {
    verschluesseln();
  } 
  if (key == 'e' ) {
    entschluesseln();
  } 
}
///////////////////////////////////////////////